package eu.jonahbauer.raytracing.render.canvas;

import eu.jonahbauer.raytracing.render.Color;
import org.jetbrains.annotations.NotNull;

import java.awt.image.BufferedImage;

public class BufferedImageCanvas extends Image {
    private final @NotNull BufferedImage image;

    public BufferedImageCanvas(int width, int height) {
        super(width, height);
        this.image = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
    }

    public @NotNull BufferedImage getImage() {
        return image;
    }

    @Override
    public void set(int x, int y, @NotNull Color color) {
        super.set(x, y, color);
        var rgb = color.red() << 16 | color.green() << 8 | color.blue();
        image.setRGB(x, y, rgb);
    }
}
